package vista;


import Controlador.Exceptions.VerticeException;
import Controlador.TDA.grafos.GrafoDE;
import Controlador.TDA.grafos.GrafoEND;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import vista.Modelo.ModeloTablaGrafo;

/**
 *
 * @author Ronald Cuenca
 */
public class grafo_Dinamico extends javax.swing.JFrame {

    private GrafoDE gd = new GrafoDE(0, String.class);
    private ModeloTablaGrafo tgd = new ModeloTablaGrafo();
    public grafo_Dinamico() {
        this.setLocationRelativeTo(null);
        initComponents();
        jPanel4.setVisible(true);
        jPanel3.setVisible(true);
    }

    private void grafoD() throws Exception {

        if (!String.valueOf(this.nombreVertice.getText()).equalsIgnoreCase("") && -1 == gd.obtenerCodigo(String.valueOf(this.nombreVertice.getText()))) {
             GrafoDE aux = gd;
                     this.gd = new GrafoEND(aux.numVertices() + 1, String.class);
                    for (int i = 1; i <= aux.numVertices(); i++) {
                        gd.etiquetarVertice(i, aux.obtenerEtiqueta(i));
                     }
                    for (int i = 1; i <= aux.numVertices(); i++) {
                        for (int j = 0; j < aux.adyacente(i).getSize(); j++) {
                            gd.insertarAristaE(aux.obtenerEtiqueta(i), aux.obtenerEtiqueta(aux.adyacente(i).obtenerDato(j).getDestino()), (Double) aux.existeAristaE(aux.obtenerEtiqueta(i), aux.obtenerEtiqueta(aux.adyacente(i).obtenerDato(j).getDestino()))[1]);
                        }
                    }
                    gd.etiquetarVertice(gd.numVertices(), String.valueOf(this.nombreVertice.getText()));           
        } else {
            JOptionPane.showMessageDialog(null, "Error");
        }
 
        cbxOrigen1.removeAllItems();
        cbxDestino.removeAllItems();
        for (int i = 1; i <= gd.numVertices(); i++) {
            cbxOrigen1.addItem(String.valueOf(gd.obtenerEtiqueta(i)));
            cbxDestino.addItem(String.valueOf(gd.obtenerEtiqueta(i)));
            cargarTabla();
              this.nombreVertice.setText(null);
        }
    }

    private void cargarTabla() throws Exception {
        tgd.setGrafoED(gd);
        tblTabla.setModel(tgd);
        tgd.fireTableStructureChanged();
        tblTabla.updateUI();
    }
    
    private static boolean isNumeric(String cadena){
	try {
		Double.parseDouble(cadena);
		return true;
	} catch (NumberFormatException nfe){
		return false;
	}
}

    private void adyacencias() throws Exception {
        String i = String.valueOf(cbxOrigen1.getSelectedItem().toString());
        String j = String.valueOf(cbxDestino.getSelectedItem().toString());

        if (i.equalsIgnoreCase(j)) {
            JOptionPane.showMessageDialog(null, "Vertices iguales", "ERROR", JOptionPane.ERROR_MESSAGE);
        } else {
            try {
                if (isNumeric(pesoVertice.getText())&&!pesoVertice.getText().equals("")) {
                    gd.insertarAristaE(i, j, Double.parseDouble(this.pesoVertice.getText()));
                cargarTabla();
                }else{
                    JOptionPane.showMessageDialog(null, "Ingrese peso numerico");
                }
            } catch (VerticeException ex) {
                System.out.println("ERROR EN INSERTAR ADYACENCIA: " + ex);
                JOptionPane.showMessageDialog(null, "No se puede insertar", "ERROR", JOptionPane.ERROR_MESSAGE);
            }
        }
         this.pesoVertice.setText(null);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        TipoGrafo = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        cbxDestino = new javax.swing.JComboBox<>();
        pesoVertice = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        cbxOrigen1 = new javax.swing.JComboBox<>();
        Unir = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblTabla = new javax.swing.JTable();
        btnMostrar = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        nombreVertice = new javax.swing.JTextField();
        btnModificar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(null);

        jPanel1.setLayout(null);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Aristas"));

        jLabel2.setText("VOrigen");

        jLabel3.setText("VDestino");

        cbxDestino.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0" }));

        jLabel6.setText("Peso :");

        cbxOrigen1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0" }));

        Unir.setBackground(new java.awt.Color(255, 255, 255));
        Unir.setText("Unir");
        Unir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                UnirActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(cbxOrigen1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(19, 19, 19)
                        .addComponent(jLabel3)
                        .addGap(18, 18, Short.MAX_VALUE)
                        .addComponent(cbxDestino, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(204, 204, 204))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pesoVertice, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(35, 35, 35)
                        .addComponent(Unir, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(175, 175, 175))))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3)
                    .addComponent(cbxOrigen1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbxDestino, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(pesoVertice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(Unir))
                .addContainerGap(39, Short.MAX_VALUE))
        );

        jPanel1.add(jPanel3);
        jPanel3.setBounds(270, 90, 310, 130);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Tablas", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION));
        jPanel4.setLayout(null);

        tblTabla.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(tblTabla);

        jPanel4.add(jScrollPane1);
        jScrollPane1.setBounds(10, 30, 420, 100);

        btnMostrar.setBackground(new java.awt.Color(255, 255, 255));
        btnMostrar.setText("Cargar");
        btnMostrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnMostrarActionPerformed(evt);
            }
        });
        jPanel4.add(btnMostrar);
        btnMostrar.setBounds(170, 150, 75, 25);

        jPanel1.add(jPanel4);
        jPanel4.setBounds(80, 240, 440, 200);

        jLabel1.setFont(new java.awt.Font("Segoe UI", 1, 14)); // NOI18N
        jLabel1.setText("Grafo Etiquetado");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(230, 50, 120, 20);

        jLabel7.setText("Palabra:");
        jPanel1.add(jLabel7);
        jLabel7.setBounds(40, 90, 113, 20);
        jPanel1.add(nombreVertice);
        nombreVertice.setBounds(100, 90, 100, 22);

        btnModificar.setText("Agregar");
        btnModificar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnModificarActionPerformed(evt);
            }
        });
        jPanel1.add(btnModificar);
        btnModificar.setBounds(110, 130, 75, 25);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(0, 0, 610, 440);

        setSize(new java.awt.Dimension(644, 495));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnMostrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnMostrarActionPerformed
        FrmGrafoVista frm = new FrmGrafoVista(gd);
        frm.setSize(400, 400);
        frm.setVisible(true);
    }//GEN-LAST:event_btnMostrarActionPerformed

    private void btnModificarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnModificarActionPerformed
        try {
            this.grafoD();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, "Error en grafos", "ERROR", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btnModificarActionPerformed

    private void UnirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_UnirActionPerformed
        try {
            adyacencias();
        } catch (Exception ex) {
            Logger.getLogger(grafo_Dinamico.class.getName()).log(Level.SEVERE, null, ex);
        }        // TODO add your handling code here:        // TODO add your handling code here:        // TODO add your handling code here:        // TODO add your handling code here:
    }//GEN-LAST:event_UnirActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(grafo_Dinamico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(grafo_Dinamico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(grafo_Dinamico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(grafo_Dinamico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new grafo_Dinamico().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup TipoGrafo;
    private javax.swing.JButton Unir;
    private javax.swing.JButton btnModificar;
    private javax.swing.JButton btnMostrar;
    private javax.swing.JComboBox<String> cbxDestino;
    private javax.swing.JComboBox<String> cbxOrigen1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField nombreVertice;
    private javax.swing.JTextField pesoVertice;
    private javax.swing.JTable tblTabla;
    // End of variables declaration//GEN-END:variables
}
